// create billobard and appply projection matrix
#version 430

layout (points) in; // points in
layout(triangle_strip, max_vertices = 4) out; // quad out

uniform mat4 ProjectionMatrix;

in vData { // from vertex shader
	float TTL1;
	// additional vertex data goes here
    //float vColor;
} vertex [];

out vec2 TexCoord0;

//const float PI = 3.1415926;

flat out float TTL0; // flat: no interpolation between vertices


void main () {
	TTL0 = vertex[0].TTL1;

    const vec2 size = vec2(.01f, .01f) * clamp(TTL0, 0.0, 1.0);

    vec4 P = gl_in[0].gl_Position; // position in view-space

    vec2 va = P.xy + vec2(-0.5, -0.5) * size; // bottom-left corner
    gl_Position = ProjectionMatrix * vec4(va, P.zw); // apply projection matrix here!
    TexCoord0 = vec2(0.0, 0.0);
    EmitVertex();


    vec2 vb = P.xy + vec2(0.5, -0.5) * size; // bottom-right corner
    gl_Position = ProjectionMatrix * vec4(vb, P.zw); // apply projection matrix here!
    TexCoord0 = vec2(0.0, 1.0);
    EmitVertex();

    vec2 vc = P.xy + vec2(-0.5, 0.5) * size; // top-left corner
    gl_Position = ProjectionMatrix * vec4(vc, P.zw); // apply projection matrix here!
    TexCoord0 = vec2(1.0, 0.0);
    EmitVertex();
    
    
    vec2 vd = P.xy + vec2(0.5, 0.5) * size; // top-right corner
    gl_Position = ProjectionMatrix * vec4(vd, P.zw); // apply projection matrix here!
    TexCoord0 = vec2(1.0, 1.0);
    EmitVertex();
 
    EndPrimitive();


}
